Draft PointArray: Difference between revisions

From FreeCAD Documentation
(Better links)
(Better links)
Line 46: Line 46:
# Select the object that you wish to distribute.
# Select the object that you wish to distribute.
# Select a point compound.
# Select a point compound.
# Press the {{Button|[[Image:Draft_PointArray.svg|16px]] [[Draft PointArray|Draft PointArray]]}} button.
# Press the {{Button|[[Image:Draft_PointArray.svg|16px]] [[Draft_PointArray|PointArray]]}} button.


<!--T:19-->
<!--T:19-->
Line 57: Line 57:
* Create various {{Button|[[File:Draft_Point.svg|16px]] [[Draft_Point|Draft Points]]}} or {{Button|[[File:Part_Point.svg|16px]] [[Part_Point|Part Points]]}}, and then press {{Button|[[File:Part_Compound.svg|16px]] [[Part_Compound|Part Compound]]}} to create the compound.
* Create various {{Button|[[File:Draft_Point.svg|16px]] [[Draft_Point|Draft Points]]}} or {{Button|[[File:Part_Point.svg|16px]] [[Part_Point|Part Points]]}}, and then press {{Button|[[File:Part_Compound.svg|16px]] [[Part_Compound|Part Compound]]}} to create the compound.
* Repeat the previous method but instead of a compound use {{Button|[[Image:Draft_Upgrade.svg|16px]] [[Draft_Upgrade|Draft Upgrade]]}} to create a "Block".
* Repeat the previous method but instead of a compound use {{Button|[[Image:Draft_Upgrade.svg|16px]] [[Draft_Upgrade|Draft Upgrade]]}} to create a "Block".
* Create a {{Button|[[File:Sketcher_NewSketch.svg|16px]] [[Sketch|Sketch]]}}, and inside add various {{Button|[[File:Sketcher_CreatePoint.svg|16px]] [[Sketcher_CreatePoint|Points]]}}.
* Create a {{Button|[[File:Sketcher_NewSketch.svg|16px]] [[Sketch|Sketch]]}}, and inside add various {{Button|[[File:Sketcher_CreatePoint.svg|16px]] [[Sketcher_CreatePoint|Sketcher Points]]}}.


<!--T:25-->
<!--T:25-->
Line 63: Line 63:


<!--T:26-->
<!--T:26-->
{{Emphasis|Note:}} in the case of {{Button|[[File:Draft_Point.svg|16px]] [[Draft_Point|Draft Point]]}} and {{Button|[[File:Part_Point.svg|16px]] [[Part_Point|Part Point]]}} the array will try to position the copies using the {{PropertyData|Placement}} of the point. In the case of a sketcher {{Button|[[File:Sketcher_CreatePoint.svg|16px]] [[Sketcher_CreatePoint|Point]]}}, the position will be taken from its internal {{incode|X}}, {{incode|Y}}, and {{incode|Z}} attributes.
{{Emphasis|Note:}} in the case of {{Button|[[File:Draft_Point.svg|16px]] [[Draft_Point|Draft Point]]}} and {{Button|[[File:Part_Point.svg|16px]] [[Part_Point|Part Point]]}} the array will try to position the copies using the {{PropertyData|Placement}} of the point. In the case of a {{Button|[[File:Sketcher_CreatePoint.svg|16px]] [[Sketcher_CreatePoint|Sketcher Point]]}}, the position will be taken from its internal {{incode|X}}, {{incode|Y}}, and {{incode|Z}} attributes.


<!--T:27-->
<!--T:27-->

Revision as of 00:08, 29 June 2020

Draft PointArray

Menu location
Draft → PointArray
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.18
See also
OrthoArray, PolarArray, CircularArray, PathArray

Description

The Draft PointArray tool places copies of a selected shape along various selected points.

The PointArray tool can be used on any object that has a Part TopoShape, meaning 2D shapes created with the Draft Workbench, but also 3D solids created with other workbenches, for example, Part, PartDesign, or Arch.

Object arranged at specific points

Usage

  1. Select the object that you wish to distribute.
  2. Select a point compound.
  3. Press the PointArray button.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

Point compound

The point compound object can be created in different ways.

In essence, the object to be used as the compound must have one of three properties, DataComponents, DataLinks, or DataGeometry, and inside that compound, there must be at least one point with DataX, DataY, and DataZ properties.

Note: in the case of Draft Point and Part Point the array will try to position the copies using the DataPlacement of the point. In the case of a Sketcher Point, the position will be taken from its internal X, Y, and Z attributes.

Note 2: for Draft Point its DataPlacement always follows the values of DataX, DataY, DataZ, so modifying these values is enough to produce the desired displacement. However, for Part Point, the net displacement is given by the sum of DataPlacement with the vector with components DataX, DataY, and DataZ.

Options

There are no options for this tool. Either it works with the selected objects or not.

Properties

A PointArray is derived from a Part Feature (Part::Feature class), therefore it shares all the latter's properties. In addition to the properties described in Part Feature, the PointArray has the following properties in the property editor.

Objects

  • DataBase (Link): the object to duplicate; it must have a Part TopoShape.
  • DataCount (Integer): (read-only) specifies the number of copies in the array. This property is read-only because the number of copies is determined by the number of points inside of DataPoint Object.
  • DataExtra Placement (Placement): specifies an additional placement, translation and rotation, that will be applied to each copy in the array. Each copy normally appears with the same rotation as the DataBase object; with this property it is possible to provide additional rotation, or counter the original rotation, and make small adjustments to the position of the copies. introduced in version 0.19
  • DataPoint Object (Link): specifies a compound object with points that indicate where the copies of the DataBase object will appear. The compound object needs to have one of DataLinks, DataComponents, or DataGeometry properties, and contain at least one element with DataX, DataY, and DataZ attributes.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The PointArray tool can be used in macros and from the Python console by using the following function:

Older call

point_array = makePointArray(base_object, point_object)

New call

point_array = make_point_array(base_object, point_object, extra=None):
  • Creates a "PointArray" object from the base_object, by placing the copies in the points contained within point_object.
    • point_object should have one of Geometry, Links, or Components attributes containing points.
    • Instead of a reference to an object, base_object and point_object can also be Labels (strings) of objects existing in the current document.
    • extra can be a full App.Placement, or just an App.Vector or App.Rotation.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

polygon = Draft.make_polygon(3, radius=500.0)

p1 = Draft.make_point(App.Vector(1500, 0, 0))
p2 = Draft.make_point(App.Vector(2500, 0, 0))
p3 = Draft.make_point(App.Vector(2000, 1000, 0))

compound = doc.addObject("Part::Compound", "Compound")
compound.Links = [p1, p2, p3]

point_array = Draft.make_point_array(polygon, compound)
doc.recompute()